show databases;

create database if not exists spark_web  CHARACTER SET utf8mb4;

use spark_web;
#3.3创建一个数据库汇总表
create table sum (
	imei varchar(10) default null comment'用户编号',
	log_times int(2) default null comment'登陆次数',
	online_time int(10) default null comment'在线时长(秒)'
) engine=innodb default charset=utf8;


#3.4创建一个数据明细表
create table detail (
	imei varchar(10) default null comment'用户编号',
	first_login_time varchar(100) default null comment'首次登录时间',
	online_time int(10) default null comment'在线时长(秒)'
) engine=innodb default charset=utf8;

#3.5创建一个数据原始明细表
create table cleanMap (
	imei varchar(10) default null comment'用户编号',
	logid varchar(100) default null comment'登录时间',
	requestip varchar(11) default null comment'登录IP地址',
	areacode varchar(11) default null comment'登录区域',
	requesttype varchar(11) default null comment'请求类型',
	channelne varchar(11) default null comment'渠道'
)engine=innodb default charset=utf8;


#3.6创建一个区域维表
create table t_dim_area (
	areacode varchar(11) default null comment'区域编码',
	areaname varchar(100) default null comment'区域名称'
)engine=innodb default charset=utf8;
 

#一定要插入数据，否则前后端无法进行数据分析

insert into  t_dim_area  values('0','浙江省丽水市');
insert into  t_dim_area  values('1','福建省南平市');
insert into  t_dim_area  values('2','福建省福州市');
#3.7 创建一个渠道维表
create table t_dim_channel (
	channelno varchar(11) default null comment'渠道编号',
	channelname varchar(100) default null comment'渠道名称'
)engine=innodb default charset=utf8 row_format=dynamic;
 
insert into t_dim_channel values ('0','手机');
insert into t_dim_channel values ('1','PC');
insert into t_dim_channel values ('2','平板电脑');


#3.8创建请求类型维表
create table t_dim_requesttype (
	requesttype varchar(11) default null comment'请求类型',
	requesttypename varchar(100) default null comment'请求类型名称'
)engine=innodb default charset=utf8 row_format=dynamic;
 
insert into t_dim_requesttype values ('0','GET方式');
insert into t_dim_requesttype values ('1','POST方式');
 

#3.9创建一个五个视图
#3.9.1用户渠道趋势分析
create or replace view v_area_channel as
	select b.areaname,c.channelname,count(distinct imei) num
	from cleanMap a,t_dim_area b,t_dim_channel c
	where a.areacode=b.areacode and a.channelne=c.channelno
	group by b.areaname,c.channelname;
#3.9.2用户请求类型对比情况
create or replace view v_area_requesttype as
	select b.areaname,c.requesttypename,count(distinct imei) num
	from cleanMap a,t_dim_area b,t_dim_requesttype c
	where a.areacode=b.areacode and a.requesttype=c.requesttype
	group by b.areaname,c.requesttypename;
#3.9.3用户渠道饼图分析
create or replace view v_channelno as
	select b.channelname,count(distinct imei) num
	from cleanMap a,t_dim_channel b
	where a.channelne=b.channelno
	group by b.channelname;
#3.9.4用户登录情况分析
create or replace view v_user_login as
	select distinct a.imei,a.log_times,b.first_login_time,a.online_time
	from sum a,detail b
	where a.imei=b.imei;
#3.9.5用户详细情况分析
create or replace view v_user_detail as
	select distinct a.imei,a.requestip,d.requesttypename,c.first_login_time,
	b.log_times,b.online_time,e.areaname,f.channelname
	from cleanMap a,sum b,detail c,t_dim_requesttype d,t_dim_area e,t_dim_channel f
	where a.imei=b.imei and a.imei=c.imei
	and a.requesttype=d.requesttype
	and a.areacode=e.areacode and a.channelne=f.channelno;
#查看spark_web的表

show tables;


show databases;
use spark_web;
show tables;

select * from detail;

select * from sum;

select * from cleanMap;