package date_20250513;

import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.Producer;
import org.apache.kafka.clients.producer.ProducerConfig;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.kafka.common.serialization.IntegerSerializer;
import org.apache.kafka.common.serialization.StringSerializer;

import java.util.Properties;


/**
 * 生产者类
 */

public class MyProducer {

    public static void main(String[] args) {
        //1.使用Proerties定义配置属性
        Properties props = new Properties();
        //设置生产者Broker服务器连接地址
        props.setProperty(ProducerConfig.BOOTSTRAP_SERVERS_CONFIG, "hadoop102:9092");
        //指定topic
        String topic = "topic02";
        //设置序列化key程序类
        props.setProperty(ProducerConfig.KEY_SERIALIZER_CLASS_CONFIG, StringSerializer.class.getName());
        //设置序列号化value程序类，此处不一定是非得时Integer，也可以是String
        props.setProperty(ProducerConfig.VALUE_SERIALIZER_CLASS_CONFIG, StringSerializer.class.getName());
        //2.定义消息生产者对象，依靠此对象可以进行消息的传递
        Producer<String, String> producer = new KafkaProducer<String, String>(props);

        //3.循环发送10条消息
        for (int i = 0; i < 10; i++) {
            //发送消息，此方式只负责发送消息，不关心是否发送成功
            //第一个参数：主题名称
            //第二个参数，消息的key值
            //第三个参数，消息的value值
            System.out.println(i);
            //producer.send(new ProducerRecord<String, String>(topic,"hello to kafka" + i, String.valueOf(i)));

            producer.send(new ProducerRecord<String, String>(topic, "hello to kafka" + i));

        }
        //4.关闭生产者，释放资源
        producer.close();
    }
}
