package date_20250520

import org.apache.spark.SparkConf
import org.apache.spark.streaming.dstream.{DStream, ReceiverInputDStream}
import org.apache.spark.streaming.{Seconds, StreamingContext}

object SparkStreamingTest1 {
    def main(args: Array[String]): Unit = {
        val conf: SparkConf = new SparkConf().setMaster("local[2]").setAppName("NetworkWordCount")

        val ssc = new StreamingContext(conf, Seconds(5))

        //        val data: ReceiverInputDStream[String] = ssc.socketTextStream("hadoop102", port = 9999)

        val data: DStream[String] = ssc.textFileStream("spark-lesson/src/main/scala/date_20250520/input/")

        data
          .flatMap(_.split(" "))
          .map(x => (x, 1))
          .reduceByKey(_ + _)
          .print()

        ssc.start()
        ssc.awaitTermination()
    }
}
